Qwt User's Guide: QwtCounter Class Reference

Qwt User's Guide 6.3.0

Loading...
Searching...
No Matches
Public Types | Public Slots | Signals | Public Member Functions | Protected Member Functions | List of all members
QwtCounter Class Reference

The Counter Widget. More...

`#include <qwt_counter.h>`

Inheritance diagram for QwtCounter:

## Public Types
enum | Button { Button1 , Button2 , Button3 , ButtonCnt }
| Button index. More...

## Public Slots
void | setValue (double)
| Set a new value without adjusting to the step raster.

## Signals
void | buttonReleased (double value)
void | valueChanged (double value)

## Public Member Functions
| QwtCounter (QWidget *parent=NULL)
virtual | ~QwtCounter ()
| Destructor.
void | setValid (bool)
bool | isValid () const
void | setWrapping (bool)
| En/Disable wrapping.
bool | wrapping () const
bool | isReadOnly () const
void | setReadOnly (bool)
| Allow/disallow the user to manually edit the value.
void | setNumButtons (int)
int | numButtons () const
void | setIncSteps (QwtCounter::Button, int numSteps)
int | incSteps (QwtCounter::Button) const
virtual QSize | sizeHint () const override
| A size hint.
double | singleStep () const
void | setSingleStep (double stepSize)
| Set the step size of the counter.
void | setRange (double min, double max)
| Set the minimum and maximum values.
double | minimum () const
void | setMinimum (double)
double | maximum () const
void | setMaximum (double)
void | setStepButton1 (int nSteps)
int | stepButton1 () const
| returns the number of increment steps for button 1
void | setStepButton2 (int nSteps)
int | stepButton2 () const
| returns the number of increment steps for button 2
void | setStepButton3 (int nSteps)
int | stepButton3 () const
| returns the number of increment steps for button 3
double | value () const

## Protected Member Functions
virtual bool | event (QEvent *) override
virtual void | wheelEvent (QWheelEvent *) override
virtual void | keyPressEvent (QKeyEvent *) override

## Detailed Description

The Counter Widget.

A Counter consists of a label displaying a number and one ore more (up to three) push buttons on each side of the label which can be used to increment or decrement the counter's value.

A counter has a range from a minimum value to a maximum value and a step size. When the wrapping property is set the counter is circular.

The number of steps by which a button increments or decrements the value can be specified using setIncSteps(). The number of buttons can be changed with setNumButtons().

Example:

#include <qwt_counter.h>
QwtCounter *counter = new QwtCounter(parent);
counter->setRange(0.0, 100.0); // From 0.0 to 100
counter->setSingleStep( 1.0 ); // Step size 1.0
counter->setNumButtons(2); // Two buttons each side
counter->setIncSteps(QwtCounter::Button1, 1); // Button 1 increments 1 step
counter->setIncSteps(QwtCounter::Button2, 20); // Button 2 increments 20 steps
connect(counter, SIGNAL(valueChanged(double)), myClass, SLOT(newValue(double)));
QwtCounter
The Counter Widget.
Definition qwt_counter.h:49
QwtCounter::Button1
@ Button1
Button intended for minor steps.
Definition qwt_counter.h:70
QwtCounter::Button2
@ Button2
Button intended for medium steps.
Definition qwt_counter.h:73
QwtCounter::setNumButtons
void setNumButtons(int)
Definition qwt_counter.cpp:362
QwtCounter::setIncSteps
void setIncSteps(QwtCounter::Button, int numSteps)
Definition qwt_counter.cpp:403
QwtCounter::setRange
void setRange(double min, double max)
Set the minimum and maximum values.
Definition qwt_counter.cpp:241
QwtCounter::valueChanged
void valueChanged(double value)
QwtCounter::QwtCounter
QwtCounter(QWidget *parent=NULL)
Definition qwt_counter.cpp:65
QwtCounter::setSingleStep
void setSingleStep(double stepSize)
Set the step size of the counter.
Definition qwt_counter.cpp:319

Definition at line 48 of file qwt_counter.h.

## Member Enumeration Documentation

## ◆ Button

enum QwtCounter::Button

Button index.

Enumerator
Button1 | Button intended for minor steps.
Button2 | Button intended for medium steps.
Button3 | Button intended for large steps.
ButtonCnt | Number of buttons.

Definition at line 67 of file qwt_counter.h.

## Constructor & Destructor Documentation

## ◆ QwtCounter()

QwtCounter::QwtCounter | ( | QWidget * | parent = NULL | ) |
| explicit

The counter is initialized with a range is set to [0.0, 1.0] with 0.01 as single step size. The value is invalid.

The default number of buttons is set to 2. The default increments are:

- Button 1: 1 step
- Button 2: 10 steps
- Button 3: 100 steps

Parameters

  parent |

Definition at line 65 of file qwt_counter.cpp.

## ◆ ~QwtCounter()

QwtCounter::~QwtCounter | ( |  | ) |
| virtual

Destructor.

Definition at line 127 of file qwt_counter.cpp.

## Member Function Documentation

## ◆ buttonReleased

void QwtCounter::buttonReleased | ( | double | value | ) |
| signal

This signal is emitted when a button has been released

Parameters

  value | The new value

## ◆ event()

bool QwtCounter::event | ( | QEvent * | event | ) |
| overrideprotectedvirtual

Handle QEvent::PolishRequest events

Parameters

  event | Event

Returns
  see QWidget::event()

Definition at line 485 of file qwt_counter.cpp.

## ◆ incSteps()

int QwtCounter::incSteps | ( | QwtCounter::Button | button | ) | const

Returns
  The number of steps by which a specified button increments the value or 0 if the button is invalid.

Parameters

  button | Button index

See also
  setIncSteps()

Definition at line 416 of file qwt_counter.cpp.

## ◆ isReadOnly()

bool QwtCounter::isReadOnly | ( |  | ) | const

Returns
  True, when the line line edit is read only. (default is no)

See also
  setReadOnly()

Definition at line 186 of file qwt_counter.cpp.

## ◆ isValid()

bool QwtCounter::isValid | ( |  | ) | const

Returns
  True, if the value is valid

See also
  setValid(), setValue()

Definition at line 166 of file qwt_counter.cpp.

## ◆ keyPressEvent()

void QwtCounter::keyPressEvent | ( | QKeyEvent * | event | ) |
| overrideprotectedvirtual

Handle key events

- Ctrl + Qt::Key_Home
  Step to minimum()
- Ctrl + Qt::Key_End
  Step to maximum()
- Qt::Key_Up
  Increment by incSteps(QwtCounter::Button1)
- Qt::Key_Down
  Decrement by incSteps(QwtCounter::Button1)
- Qt::Key_PageUp
  Increment by incSteps(QwtCounter::Button2)
- Qt::Key_PageDown
  Decrement by incSteps(QwtCounter::Button2)
- Shift + Qt::Key_PageUp
  Increment by incSteps(QwtCounter::Button3)
- Shift + Qt::Key_PageDown
  Decrement by incSteps(QwtCounter::Button3)

Parameters

  event | Key event

Definition at line 524 of file qwt_counter.cpp.

## ◆ maximum()

double QwtCounter::maximum | ( |  | ) | const

Returns
  The maximum of the range

See also
  setRange(), setMaximum(), minimum()

Definition at line 306 of file qwt_counter.cpp.

## ◆ minimum()

double QwtCounter::minimum | ( |  | ) | const

Returns
  The minimum of the range

See also
  setRange(), setMinimum(), maximum()

Definition at line 286 of file qwt_counter.cpp.

## ◆ numButtons()

int QwtCounter::numButtons | ( |  | ) | const

Returns
  The number of buttons on each side of the widget.

See also
  setNumButtons()

Definition at line 388 of file qwt_counter.cpp.

## ◆ setIncSteps()

void QwtCounter::setIncSteps | ( | QwtCounter::Button | button,
|  | int | numSteps )

Specify the number of steps by which the value is incremented or decremented when a specified button is pushed.

Parameters

  button | Button index
  numSteps | Number of steps

See also
  incSteps()

Definition at line 403 of file qwt_counter.cpp.

## ◆ setMaximum()

void QwtCounter::setMaximum | ( | double | value | ) |

Set the maximum value of the range

Parameters

  value | Maximum value

See also
  setRange(), setMinimum(), maximum()

Definition at line 297 of file qwt_counter.cpp.

## ◆ setMinimum()

void QwtCounter::setMinimum | ( | double | value | ) |

Set the minimum value of the range

Parameters

  value | Minimum value

See also
  setRange(), setMaximum(), minimum()

Note
  The maximum is adjusted if necessary to ensure that the range remains valid.

Definition at line 277 of file qwt_counter.cpp.

## ◆ setNumButtons()

void QwtCounter::setNumButtons | ( | int | numButtons | ) |

Specify the number of buttons on each side of the label

Parameters

  numButtons | Number of buttons

See also
  numButtons()

Definition at line 362 of file qwt_counter.cpp.

## ◆ setRange()

void QwtCounter::setRange | ( | double | min,
|  | double | max )

Set the minimum and maximum values.

The maximum is adjusted if necessary to ensure that the range remains valid. The value might be modified to be inside of the range.

Parameters

  min | Minimum value
  max | Maximum value

See also
  minimum(), maximum()

Definition at line 241 of file qwt_counter.cpp.

## ◆ setReadOnly()

void QwtCounter::setReadOnly | ( | bool | on | ) |

Allow/disallow the user to manually edit the value.

Parameters

  on | True disable editing

See also
  isReadOnly()

Definition at line 177 of file qwt_counter.cpp.

## ◆ setSingleStep()

void QwtCounter::setSingleStep | ( | double | stepSize | ) |

Set the step size of the counter.

A value <= 0.0 disables stepping

Parameters

  stepSize | Single step size

See also
  singleStep()

Definition at line 319 of file qwt_counter.cpp.

## ◆ setStepButton1()

void QwtCounter::setStepButton1 | ( | int | nSteps | ) |

Set the number of increment steps for button 1

Parameters

  nSteps | Number of steps

Definition at line 429 of file qwt_counter.cpp.

## ◆ setStepButton2()

void QwtCounter::setStepButton2 | ( | int | nSteps | ) |

Set the number of increment steps for button 2

Parameters

  nSteps | Number of steps

Definition at line 444 of file qwt_counter.cpp.

## ◆ setStepButton3()

void QwtCounter::setStepButton3 | ( | int | nSteps | ) |

Set the number of increment steps for button 3

Parameters

  nSteps | Number of steps

Definition at line 459 of file qwt_counter.cpp.

## ◆ setValid()

void QwtCounter::setValid | ( | bool | on | ) |

Set the counter to be in valid/invalid state

When the counter is set to invalid, no numbers are displayed and the buttons are disabled.

Parameters

  on | If true the counter will be set as valid

See also
  setValue(), isValid()

Definition at line 142 of file qwt_counter.cpp.

## ◆ setValue

void QwtCounter::setValue | ( | double | value | ) |
| slot

Set a new value without adjusting to the step raster.

The state of the counter is set to be valid.

Parameters

  value | New value

See also
  isValid(), value(), valueChanged()

Warning
  The value is clipped when it lies outside the range.

Definition at line 202 of file qwt_counter.cpp.

## ◆ setWrapping()

void QwtCounter::setWrapping | ( | bool | on | ) |

En/Disable wrapping.

If wrapping is true stepping up from maximum() value will take you to the minimum() value and vice versa.

Parameters

  on | En/Disable wrapping

See also
  wrapping()

Definition at line 342 of file qwt_counter.cpp.

## ◆ singleStep()

double QwtCounter::singleStep | ( |  | ) | const

Returns
  Single step size

See also
  setSingleStep()

Definition at line 328 of file qwt_counter.cpp.

## ◆ sizeHint()

QSize QwtCounter::sizeHint | ( |  | ) | const
| overridevirtual

A size hint.

Definition at line 759 of file qwt_counter.cpp.

## ◆ stepButton1()

int QwtCounter::stepButton1 | ( |  | ) | const

returns the number of increment steps for button 1

Definition at line 435 of file qwt_counter.cpp.

## ◆ stepButton2()

int QwtCounter::stepButton2 | ( |  | ) | const

returns the number of increment steps for button 2

Definition at line 450 of file qwt_counter.cpp.

## ◆ stepButton3()

int QwtCounter::stepButton3 | ( |  | ) | const

returns the number of increment steps for button 3

Definition at line 465 of file qwt_counter.cpp.

## ◆ value()

double QwtCounter::value | ( |  | ) | const

Returns
  Current value of the counter

See also
  setValue(), valueChanged()

Definition at line 225 of file qwt_counter.cpp.

## ◆ valueChanged

void QwtCounter::valueChanged | ( | double | value | ) |
| signal

This signal is emitted when the counter's value has changed

Parameters

  value | The new value

## ◆ wheelEvent()

void QwtCounter::wheelEvent | ( | QWheelEvent * | event | ) |
| overrideprotectedvirtual

Handle wheel events

Parameters

  event | Wheel event

Definition at line 591 of file qwt_counter.cpp.

## ◆ wrapping()

bool QwtCounter::wrapping | ( |  | ) | const

Returns
  True, when wrapping is set

See also
  setWrapping()

Definition at line 351 of file qwt_counter.cpp.